                                list p=16f88, r=dec
                                errorlevel -306 ; no page boundary warnings
                                errorlevel -302 ; no bank 0 warnings

datahi_set macro val
  bsf 3, 6 ; STATUS<rp1>
  endm
datahi_clr macro val
  bcf 3, 6 ; STATUS<tp1>
  endm
datalo_set macro val
  bsf 3, 5 ; STATUS<rp0>
  endm
datalo_clr macro val
  bcf 3, 5 ; STATUS<rp0>
  endm
irp_clr macro
  bcf 3, 7 ; STATUS<irp>
  endm
irp_set macro
  bsf 3, 7 ; STATUS<irp>
  endm
branchlo_set macro lbl
  bsf 10, 3 ; PCLATH<3>
  endm
branchlo_clr macro lbl
  bcf 10, 3 ; PCLATH<3>
  endm
v_on                           EQU 1
v_off                          EQU 0
v__status                      EQU 0x0003
v__z                           EQU 2
v__c                           EQU 0
v_porta                        EQU 0x0005
v_portb                        EQU 0x0006
v_trisa                        EQU 0x0085
v_pin_a0                       EQU 0x0005    ; porta : 0
v_pin_a1                       EQU 0x0005    ; porta : 1
v_pin_a2                       EQU 0x0005    ; porta : 2
v_pin_a3                       EQU 0x0005    ; porta : 3
v_pin_a4                       EQU 0x0005    ; porta : 4
v_pin_a5                       EQU 0x0005    ; porta : 5
v_pin_a6                       EQU 0x0005    ; porta : 6
v_pin_a7                       EQU 0x0005    ; porta : 7
v_pin_b0                       EQU 0x0006    ; portb : 0
v_pin_b1                       EQU 0x0006    ; portb : 1
v_pin_b2                       EQU 0x0006    ; portb : 2
v_pin_b3                       EQU 0x0006    ; portb : 3
v_pin_b4                       EQU 0x0006    ; portb : 4
v_pin_b5                       EQU 0x0006    ; portb : 5
v_pin_b6                       EQU 0x0006    ; portb : 6
v_pin_b7                       EQU 0x0006    ; portb : 7
v_input                        EQU 1
v_output                       EQU 0
v_pin_a1_direction             EQU 0x0085    ; trisa : 1
v_pin_a2_direction             EQU 0x0085    ; trisa : 2
v_pin_a6_direction             EQU 0x0085    ; trisa : 6
v_pin_a7_direction             EQU 0x0085    ; trisa : 7
v__port_a_shadow               EQU 0x0023
v_breakpoint_                  EQU 0x0022
v__bitbucket                   EQU 0x0024
v__pic_state                   EQU 0x0020
v__pic_temp                    EQU 0x0020    ; _pic_state
v__btemp12                     EQU 0x0024    ; _bitbucket : 0
v__btemp13                     EQU 0x0024    ; _bitbucket : 1
v__btemp14                     EQU 0x0024    ; _bitbucket : 2
v__btemp15                     EQU 0x0024    ; _bitbucket : 3
v__btemp16                     EQU 0x0024    ; _bitbucket : 4
v__btemp17                     EQU 0x0024    ; _bitbucket : 5
v__btemp18                     EQU 0x0024    ; _bitbucket : 6
v__btemp19                     EQU 0x0024    ; _bitbucket : 7
v___x51                        EQU 0x0025
v__floop7                      EQU 0x0026
v___x49                        EQU 0x0025
v__floop6                      EQU 0x0026
v___x47                        EQU 0x0025
v__floop5                      EQU 0x0026
v___x45                        EQU 0x0025
v__floop4                      EQU 0x0026
v___n3                         EQU 0x0027
v__floop2                      EQU 0x0028
v___x17                        EQU 0x0023    ; _port_a_shadow : 2
v___x15                        EQU 0x0023    ; _port_a_shadow : 1
;    8 include pjal_88    -- standard include file for the 16f88
                               org      0
                               nop      
                               branchlo_clr l__l159
                               goto     l__l159
                               nop      
l__l159
l__main
; C:\JALV2\LIBRAR~1/16f88_inc.jal
;  403 procedure bank_0 is
;  406 end procedure
l__l1
;  408 procedure bank_1 is
;  411 end procedure
l__l3
;  413 procedure bank_2 is
;  416 end procedure
l__l5
;  418 procedure bank_3 is
;  421 end procedure
l__l7
;  457 procedure _port_A_flush is
                               goto     l__l67
l__port_a_flush
;  458   portA = _port_A_shadow
                               movf     v__port_a_shadow,w
                               movwf    v_porta
;  459 end procedure
                               return   
l__l9
;  461 procedure _port_B_flush is
;  463 end procedure
l__l11
;  465 procedure portA'put( byte in x at _port_A_shadow) is
;  467 end procedure
l__l13
;  469 procedure portB'put( byte in x at _port_B_shadow) is
;  471 end procedure
l__l15
;  473 procedure port_A_low'put( byte in x ) is
;  476 end procedure
l__l17
;  477 function port_A_low'get return byte is
;  479 end function
l__l19
;  481 procedure port_A_high'put( byte in x ) is
;  484 end procedure
l__l21
;  485 function port_A_high'get return byte is
;  487 end function
l__l23
;  489 procedure port_B_low'put( byte in x ) is
;  492 end procedure
l__l25
;  493 function port_B_low'get return byte is
;  495 end function
l__l27
;  497 procedure port_B_high'put( byte in x ) is
;  500 end procedure
l__l29
;  501 function port_B_high'get return byte is
;  503 end function
l__l31
;  506 procedure pin_A0'put( bit in x at _port_A_shadow : 0 ) is
;  508 end procedure
l__l33
;  510 procedure pin_A1'put( bit in x at _port_A_shadow : 1 ) is
l__pin_a1_put
;  511   _port_A_flush
;  512 end procedure
l__l35
;  514 procedure pin_A2'put( bit in x at _port_A_shadow : 2 ) is
l__pin_a2_put
;  515   _port_A_flush
;  516 end procedure
l__l37
;  518 procedure pin_A3'put( bit in x at _port_A_shadow : 3 ) is
;  520 end procedure
l__l39
;  522 procedure pin_A4'put( bit in x at _port_A_shadow : 4 ) is
;  524 end procedure
l__l41
;  526 procedure pin_A5'put( bit in x at _port_A_shadow : 5 ) is
;  528 end procedure
l__l43
;  530 procedure pin_A6'put( bit in x at _port_A_shadow : 6 ) is
;  532 end procedure
l__l45
;  534 procedure pin_A7'put( bit in x at _port_A_shadow : 7 ) is
;  536 end procedure
l__l47
;  539 procedure pin_B0'put( bit in x at _port_B_shadow : 0 ) is
;  541 end procedure
l__l49
;  543 procedure pin_B1'put( bit in x at _port_B_shadow : 1 ) is
;  545 end procedure
l__l51
;  547 procedure pin_B2'put( bit in x at _port_B_shadow : 2 ) is
;  549 end procedure
l__l53
;  551 procedure pin_B3'put( bit in x at _port_B_shadow : 3 ) is
;  553 end procedure
l__l55
;  555 procedure pin_B4'put( bit in x at _port_B_shadow : 4 ) is
;  557 end procedure
l__l57
;  559 procedure pin_B5'put( bit in x at _port_B_shadow : 5 ) is
;  561 end procedure
l__l59
;  563 procedure pin_B6'put( bit in x at _port_B_shadow : 6 ) is
;  565 end procedure
l__l61
;  567 procedure pin_B7'put( bit in x at _port_B_shadow : 7 ) is
;  569 end procedure
l__l63
;  572 procedure disable_a_d_functions is
;  577 end procedure
l__l65
; C:\JALV2\LIBRAR~1/pic_general.jal
;   39 procedure My_Identity (word in ID, word in Version) is
;   40 end procedure
l__l67
;   44 var volatile byte breakpoint_ = 0
                               clrf     v_breakpoint_
;   50 procedure BreakPoint'put(byte in Breakpoint_Number) is
;   53 end procedure 
l__l69
; C:\JALV2\LIBRAR~1/delay_any_mc.jal
;   60 procedure delay_1us is    ; (2) call
;   62 end procedure             ; (2)
l__l72
;   69 procedure delay_2uS is
;   72 end procedure
l__l74
;   79 procedure delay_3uS is
;   82 end procedure
l__l76
;   89 procedure delay_4uS is
;   92 end procedure
l__l78
;   99 procedure delay_5uS is
;  102 end procedure
l__l80
;  109 procedure delay_6uS is
;  112 end procedure
l__l82
;  119 procedure delay_7uS is
;  122 end procedure
l__l84
;  129 procedure delay_8uS is
;  132 end procedure
l__l86
;  139 procedure delay_9uS is
;  142 end procedure
l__l88
;  149 procedure delay_10uS (byte in N) is
;  168 end procedure
l__l90
;  175 procedure delay_1ms (byte in N) is
                               goto     l__l103
l_delay_1ms
                               datalo_clr v___n3
                               movwf    v___n3
;  176   for N loop
                               clrf     v__floop2
                               goto     l__l102
l__l101
;  177     _usec_delay(995)
                               datalo_clr v__pic_temp
                               datahi_clr v__pic_temp
                               movlw    6
                               movwf    v__pic_temp
l__l160
                               movlw    65
                               movwf    v__pic_temp+1
l__l161
                               branchhi_clr l__l161
                               branchlo_clr l__l161
                               decfsz   v__pic_temp+1,f
                               goto     l__l161
                               branchhi_clr l__l160
                               branchlo_clr l__l160
                               decfsz   v__pic_temp,f
                               goto     l__l160
                               nop      
;  178   end loop
                               incf     v__floop2,f
l__l102
                               movf     v__floop2,w
                               subwf    v___n3,w
                               btfsc    v__status, v__z
                               return   
                               btfsc    v__status, v__c
                               goto     l__l101
l__l163
;  179 end procedure
                               return   
l__l99
;  186 procedure delay_100ms (word in N) is
;  190 end procedure
l__l103
; C:\Documents and Settings\owner\Desktop\vhs bot.jal
;   14 pin_a1_direction = output     -- set pin a1 as a digital output for right servo
                               datalo_set v_trisa ; pin_a1_direction
                               bcf      v_trisa, 1 ; pin_a1_direction, 0
;   15 pin_a2_direction = output     -- set pin a1 as a digital output for left servo
                               bcf      v_trisa, 2 ; pin_a2_direction, 0
;   16 pin_a6_direction = input      -- set pin a1 as a digital input  for left bump
                               bsf      v_trisa, 6 ; pin_a6_direction, 0
;   17 pin_a7_direction = input      -- set pin a1 as a digital input  for right bump
                               bsf      v_trisa, 7 ; pin_a7_direction, 0
;   20 procedure reverse(byte in x) is       -- to go in reverse, left wheel clockwise
                               goto     l__l120
l_reverse
                               movwf    v___x45
;   22 for x loop
                               clrf     v__floop4
                               goto     l__l111
l__l110
;   23 pin_a1 = on  --  start right servo control signal
                               bsf      v__port_a_shadow, 1 ; x15, 0
                               call     l__port_a_flush
;   24 pin_a2 = on  --  start left servo control signal
                               datalo_clr v__port_a_shadow ; x17
                               bsf      v__port_a_shadow, 2 ; x17, 0
                               call     l__port_a_flush
;   25 delay_1ms(1)   -- delay 1 ms
                               movlw    1
                               call     l_delay_1ms
;   26 pin_a2 = off   -- end left servo control signal (1 ms pulse = clockwise)
                               datalo_clr v__port_a_shadow ; x17
                               bcf      v__port_a_shadow, 2 ; x17, 0
                               call     l__port_a_flush
;   27 delay_1ms(1)   -- delay another 1 ms
                               movlw    1
                               call     l_delay_1ms
;   28 pin_a1 = off   -- end right servo control signal (2 ms pulse = counter clockwise)
                               datalo_clr v__port_a_shadow ; x15
                               bcf      v__port_a_shadow, 1 ; x15, 0
                               call     l__port_a_flush
;   29 delay_1ms(18)  -- delay 18 ms fto give a 50 hz control signal
                               movlw    18
                               call     l_delay_1ms
;   30 end loop
                               datalo_clr v__floop4
                               incf     v__floop4,f
l__l111
                               movf     v__floop4,w
                               subwf    v___x45,w
                               btfsc    v__status, v__z
                               return   
                               btfsc    v__status, v__c
                               goto     l__l110
l__l165
;   31 end procedure
                               return   
l__l108
;   33 procedure forward(byte in x) is
l_forward
                               movwf    v___x47
;   34 for x loop
                               clrf     v__floop5
                               goto     l__l115
l__l114
;   35 pin_a1 = on
                               bsf      v__port_a_shadow, 1 ; x15, 0
                               call     l__port_a_flush
;   36 pin_a2 = on
                               datalo_clr v__port_a_shadow ; x17
                               bsf      v__port_a_shadow, 2 ; x17, 0
                               call     l__port_a_flush
;   37 delay_1ms(1)
                               movlw    1
                               call     l_delay_1ms
;   38 pin_a1 = off
                               datalo_clr v__port_a_shadow ; x15
                               bcf      v__port_a_shadow, 1 ; x15, 0
                               call     l__port_a_flush
;   39 delay_1ms(1)
                               movlw    1
                               call     l_delay_1ms
;   40 pin_a2 = off
                               datalo_clr v__port_a_shadow ; x17
                               bcf      v__port_a_shadow, 2 ; x17, 0
                               call     l__port_a_flush
;   41 delay_1ms(18)
                               movlw    18
                               call     l_delay_1ms
;   42 end loop
                               datalo_clr v__floop5
                               incf     v__floop5,f
l__l115
                               movf     v__floop5,w
                               subwf    v___x47,w
                               btfsc    v__status, v__z
                               return   
                               btfsc    v__status, v__c
                               goto     l__l114
l__l167
;   43 end procedure
                               return   
l__l112
;   45 procedure right(byte in x) is
l_right
                               datalo_clr v___x49
                               movwf    v___x49
;   46 for x loop
                               clrf     v__floop6
                               goto     l__l119
l__l118
;   47 pin_a1 = on
                               bsf      v__port_a_shadow, 1 ; x15, 0
                               call     l__port_a_flush
;   48 pin_a2 = on
                               datalo_clr v__port_a_shadow ; x17
                               bsf      v__port_a_shadow, 2 ; x17, 0
                               call     l__port_a_flush
;   49 delay_1ms(1)
                               movlw    1
                               call     l_delay_1ms
;   50 pin_a2 = off
                               datalo_clr v__port_a_shadow ; x17
                               bcf      v__port_a_shadow, 2 ; x17, 0
                               call     l__port_a_flush
;   51 pin_a1 = off
                               datalo_clr v__port_a_shadow ; x15
                               bcf      v__port_a_shadow, 1 ; x15, 0
                               call     l__port_a_flush
;   52 delay_1ms(18)
                               movlw    18
                               call     l_delay_1ms
;   53 end loop
                               datalo_clr v__floop6
                               incf     v__floop6,f
l__l119
                               movf     v__floop6,w
                               subwf    v___x49,w
                               btfsc    v__status, v__z
                               return   
                               btfsc    v__status, v__c
                               goto     l__l118
l__l169
;   54 end procedure
                               return   
l__l116
;   56 procedure left(byte in x) is
l_left
                               datalo_clr v___x51
                               movwf    v___x51
;   57 for x loop
                               clrf     v__floop7
                               goto     l__l123
l__l122
;   58 pin_a1 = on
                               bsf      v__port_a_shadow, 1 ; x15, 0
                               call     l__port_a_flush
;   59 pin_a2 = on
                               datalo_clr v__port_a_shadow ; x17
                               bsf      v__port_a_shadow, 2 ; x17, 0
                               call     l__port_a_flush
;   60 delay_1ms(2)
                               movlw    2
                               call     l_delay_1ms
;   61 pin_a2 = off
                               datalo_clr v__port_a_shadow ; x17
                               bcf      v__port_a_shadow, 2 ; x17, 0
                               call     l__port_a_flush
;   62 pin_a1 = off
                               datalo_clr v__port_a_shadow ; x15
                               bcf      v__port_a_shadow, 1 ; x15, 0
                               call     l__port_a_flush
;   63 delay_1ms(18)
                               movlw    18
                               call     l_delay_1ms
;   64 end loop
                               datalo_clr v__floop7
                               incf     v__floop7,f
l__l123
                               movf     v__floop7,w
                               subwf    v___x51,w
                               btfsc    v__status, v__z
                               return   
                               btfsc    v__status, v__c
                               goto     l__l122
l__l171
;   65 end procedure
                               return   
l__l120
;   67 forever loop         -- start of main program
l__l124
;   69 if pin_a6 & pin_a7 then   -- if no bump (both sensors high)
                               datalo_clr v__bitbucket ; _btemp12
                               bsf      v__bitbucket, 0 ; _btemp12
                               btfsc    v_porta, 7 ; pin_a7
                               btfss    v_porta, 6 ; pin_a6
                               bcf      v__bitbucket, 0 ; _btemp12
                               btfss    v__bitbucket, 0 ; _btemp12
                               goto     l__l126
;   70 forward(2)                 -- send 2 cycles of forward signals (40 ms)
                               movlw    2
                               call     l_forward
;   71 elsif pin_a6 & !pin_a7 then   -- if NOT a7 (right sensor low) back up and turn left
                               goto     l__l124
l__l126
                               bsf      v__bitbucket, 1 ; _btemp13
                               btfsc    v_porta, 7 ; pin_a7
                               bcf      v__bitbucket, 1 ; _btemp13
                               bsf      v__bitbucket, 2 ; _btemp14
                               btfsc    v_porta, 6 ; pin_a6
                               btfss    v__bitbucket, 1 ; _btemp13
                               bcf      v__bitbucket, 2 ; _btemp14
                               btfss    v__bitbucket, 2 ; _btemp14
                               goto     l__l127
;   72 reverse(60)                   -- send 60 cycles of reverse signals (1.2 s)
                               movlw    60
                               call     l_reverse
;   73 left(20)
                               movlw    20
                               call     l_left
;   74 elsif !pin_a6 & pin_a7 then
                               goto     l__l124
l__l127
                               bsf      v__bitbucket, 3 ; _btemp15
                               btfsc    v_porta, 6 ; pin_a6
                               bcf      v__bitbucket, 3 ; _btemp15
                               bsf      v__bitbucket, 4 ; _btemp16
                               btfsc    v_porta, 7 ; pin_a7
                               btfss    v__bitbucket, 3 ; _btemp15
                               bcf      v__bitbucket, 4 ; _btemp16
                               btfss    v__bitbucket, 4 ; _btemp16
                               goto     l__l128
;   75 reverse(60)
                               movlw    60
                               call     l_reverse
;   76 right(20)
                               movlw    20
                               call     l_right
;   77 elsif !pin_a6 & !pin_a7 then    -- exclamation point is a logical not
                               goto     l__l124
l__l128
                               bsf      v__bitbucket, 5 ; _btemp17
                               btfsc    v_porta, 6 ; pin_a6
                               bcf      v__bitbucket, 5 ; _btemp17
                               bsf      v__bitbucket, 6 ; _btemp18
                               btfsc    v_porta, 7 ; pin_a7
                               bcf      v__bitbucket, 6 ; _btemp18
                               bsf      v__bitbucket, 7 ; _btemp19
                               btfsc    v__bitbucket, 5 ; _btemp17
                               btfss    v__bitbucket, 6 ; _btemp18
                               bcf      v__bitbucket, 7 ; _btemp19
                               btfss    v__bitbucket, 7 ; _btemp19
                               goto     l__l124
;   78 reverse(60)
                               movlw    60
                               call     l_reverse
;   79 right(60)
                               movlw    60
                               call     l_right
;   80 end if
l__l129
l__l125
;   83 end loop          -- end of main program infinite loop
                               goto     l__l124
                               end     
